//+------------------------------------------------------------------+
//  Bolliinger Squeeze V8 Experiment 
//|
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define  NL    "\n"

extern bool UseHourTrade = true; // Time filter
extern int  FromHourTrade = 6; // start trading on this hour
extern int  ToHourTrade = 22; // end trading on this hour
extern bool UseLastPeriodPerams=false;// uses the high and low from last period for calculation


extern double TakeProfit = 277;
extern double Lots = 1.0;
extern double TrailingStop = 50;



extern string note1 = "Filter the Bollinger Band with";
extern string note2 = "1=Stoch; 2=CCI, 3=RSI";
extern int       triggerType=1;
extern int       stochPeriod_trigger1=14;
extern int       cciPeriod_trigger2=50;
extern int       rsiPeriod_trigger3=13;

double upB[];
double loB[];
double upB2[];
double loB2[];
double mm[];
double cciline[];
int shift;

 double BupB; 
 double BloB; 
 double BupB2;
 double BloB2;
 double Bmm;
 double Bcciline;

extern int        DisplayGapSize=30;
string            ScreenMessage, Gap;


void DisplayUserFeedback()
{

   ScreenMessage = "";
    
   
int cc;

 
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," upB: ", Gap,BupB,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," loB: ", Gap,BloB,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," upB2: ", Gap,BupB2,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," loB2: ", Gap,BloB2,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," mm: ", Gap,Bmm,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap," cciline: ", Gap,Bcciline,NL);
   
 
      
   Comment(ScreenMessage);
 
   
 
   
}//End void DisplayUserFeedback()

void BollSqueeze()
{

int       bolPrd=20;
double    bolDev=2.0;
int       keltPrd=20;
double    keltFactor=1.5;


int       cciPeriod=50;



int i,j,slippage=3;
double breakpoint=0.0;
double ema=0.0;
int peakf=0;
int peaks=0;
int valleyf=0;
int valleys=0, limit=0;
double ccis[61],ccif[61];
double delta=0;
double ugol=0;

 int counted_bars=Bars-1;
   
   double diff,d,std,bbs;
   
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-31;
   if(counted_bars>=31) limit=Bars-counted_bars-1;

   for (shift=limit;shift>=0;shift--)   {
      
      switch (triggerType) {
         case 1:
         d=iStochastic(NULL,0,stochPeriod_trigger1,3,3,MODE_SMA,0,MODE_MAIN,shift)-50;
         SetLevelValue(1,23.6);
         SetLevelValue(2,-23.6);
         IndicatorShortName("Bollinger Squeeze with Stochastic ("+stochPeriod_trigger1+",3,3)");
         break;
         case 2:
         d=iCCI(NULL,0,cciPeriod_trigger2,PRICE_CLOSE,shift);
         SetLevelValue(1,-200);
         SetLevelValue(2,-100);
         SetLevelValue(3,100);
         SetLevelValue(4,200);
         IndicatorShortName("Bollinger Squeeze with CCI ("+cciPeriod_trigger2+",CLOSE)");
         break;
         case 3:
         d=iRSI(NULL,0,rsiPeriod_trigger3,PRICE_CLOSE,shift)-50;
         SetLevelValue(1,20);
         SetLevelValue(2,-20);
         IndicatorShortName("Bollinger Squeeze with RSI ("+rsiPeriod_trigger3+",CLOSE)");
         break;
      }
      
      mm[shift]=d;Bmm=d;
      
      if(d>0) {
         
         upB[shift]=d;BupB=d;
         
      } else if (d<0){
      
         loB[shift]=d;BloB=d;
         
      }
      
      cciline[shift]=d;Bcciline=d;
      
      diff = iATR(NULL,0,keltPrd,shift)*keltFactor;
      std = iStdDev(NULL,0,bolPrd,MODE_SMA,0,PRICE_CLOSE,shift);
      bbs = bolDev * std / diff;
      
      if(bbs<1) {

         if (d > 0) {
            upB2[shift]=d;BupB2=d;
            upB[shift]=0;
            loB[shift]=0;
            loB2[shift]=0;
         } else {
            loB2[shift]=d;BloB2=d;
            loB[shift]=0;
            upB[shift]=0;
            upB2[shift]=0;
         }
      } else {

         if (d > 0) {
            upB[shift]=d;BupB=d;
            upB2[shift]=0;
            loB[shift]=0;
            loB2[shift]=0;
         } else {
            loB[shift]=d;BloB=d;
            loB2[shift]=0;
            upB[shift]=0;
            upB2[shift]=0;
         }
      }
   }
}   

int init()
{



Gap="";
   if (DisplayGapSize >0)
   {
      for ( int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   

 }
 

   return(0);
}


int deinit() 
{  Comment("");
   
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
      
 
 BollSqueeze();
 
 double M34EMA= iMA(NULL,0,34,0,MODE_EMA,PRICE_TYPICAL,0);
 
 
 
      
   string LastTradeTime=datetime;
   
   int cnt,ticket,tt=0, total;
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables


   
  
   

   
 DisplayUserFeedback();
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
 
 // check for long position (BUY) possibility
 
 if ( Close[1]<=M34EMA && Close [0]> M34EMA )  
        {
         Alert ("We have a 34 cross going up",Symbol());
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"Go Long",16384,0,Blue);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
  
  
        
        
      // check for short position (SELL) possibility && 

if ( Close[1]>=M34EMA && Close[0]<M34EMA )

        {
         Alert ("We have a 34 cross going down",Symbol());
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"Go Short",16384,0,Orange);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
        else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
     
     
     
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            
            // Check Buy position - should it be closed?   
            
         if(  Close[1]<M34EMA  ) 
         
                            {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                                
                  return(0); // exit
                  }
             
            
             
                  
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to check if short position should be closed 
           {
           
            // should it be closed?
             
           //   if ( ( CCI50<-280 && CCI21>-89 )  || ( RSI4<4.7 && RSI21<29.5  ) || ( Stoch<16.11)  )
             
             if(  Close[1]>M34EMA ) 
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow); // close position
               return(0); // exit
               
              }
            // check for trailing stop
                        
            if(TrailingStop>0)  
              { 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
        }
     }
  
   return(0);
  }
// the end.
/*
 double upB; 
 double loB; 
 double upB2;
 double loB2;
 double mm;
 double cciline;
 */